package web

import (
	"git.loafle.net/commons_go/websocket_fasthttp/websocket"
	oos "git.loafle.net/overflow/overflow_subscriber"
)

func NewSubscriberHandler(channel string) oos.SubscriberHandler {
	sh := &webSubscriberHandlers{}
	sh.Channel = channel

	return sh
}

type webSubscriberHandlers struct {
	oos.SubscriberHandlers
}

func (sh *webSubscriberHandlers) OnSubscribe(channel string, message oos.SubscribeMessage) {
	for _, uid := range message.Targets {
		if soc := socketManager.getSocket(uid); nil != soc {
			soc.WriteMessage(websocket.TextMessage, message.Message)
		}
	}
}

func (sh *webSubscriberHandlers) Validate() {
	sh.SubscriberHandlers.Validate()
}
